/* 
 * $RCSfile: xk_debug.c,v $
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 *
 *
 * $Log: xk_debug.c,v $
 * Revision 1.18.1.2  1996/11/04 23:16:39  mjk
 * Fixes for linux kernel
 *   use xPrintf
 *   errBuf is no longer a global
 *
 * Revision 1.18.1.1  1994/03/14 23:05:19  umass
 * Size of errbuf is now a manifest constant
 *
 */

#include "xk_debug.h"
#include "platform.h"
#ifndef XKMACHKERNEL
#include "x_stdio.h"
#endif /* XKMACHKERNEL */

#ifdef XK_DEBUG

int
  tracebuserror,
  tracecustom,
  traceether,
  traceevent,
  tracefixme,
  traceidle,
  traceie,
  tracememoryinit,
  traceprocesscreation,
  traceprocessswitch,
  traceprotocol,
  traceprottest,
  tracetick,
  tracetrap,
  traceuser;

char assertMessage[] = "Assertion failed: file %s, line %d\n";

#endif /* XK_DEBUG */

char  errBuf[GLOBAL_ERRBUF_SIZE];

void
xError(char *msg)
{
  xTraceLock();
  
#if defined(XKLINUXKERNEL)
  printk(msg);			/* linux kernel 			*/
#elif defined(XKMACHKERNEL)
  fprintf(stderr, "%s\n", msg);	/* mach kernel 				*/
#else
  printf("%s\n", msg);		/* user level 				*/
#endif
    
    xTraceUnlock();
} /* xError */
