/*     
 * $RCSfile: ipsec_simplespi_i.h,v $
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1994,1993,1991,1990  Arizona Board of Regents
 *
 */

#define LOCALHOSTTYPE IPhost
#define LOCALHOSTLEN  sizeof(IPhost)

#define		ACTIVE_MAP_SIZE   64
#define		PASSIVE_MAP_SIZE 128

#define	SAID_NETSIZE	4
#define	PROT_NETSIZE	2
#define IPSEC_HDR_NETSIZE (SAID_NETSIZE + PROT_NETSIZE)

#define IP_PS_HACK_FLAG 1

typedef struct header {
    XSaid	said;	/* security association identifier */
    unsigned short prot;
} ipsecHdr;

typedef struct { 
    LOCALHOSTTYPE h;
    XAlgorithm 	algo;
    int prot;
} PassiveId;

typedef struct {
    XSaid	lsaid;
    XObj	lls;
    int prot;
} ActiveId;

typedef struct pstate {
    Map   	activemap;
    Map		passivemap;
    XObj	km;
    XObj	transport;
    int		flags;
} PSTATE;

typedef struct sstate {
     XSaid	lsaid, rsaid;
     ipsecHdr	ihdr;
     int	flags;
} SSTATE;
