/*
 * $RCSfile: gen_utils.h,v $
 *
 * Universal Stub Compiler
 *
 * Copyright (c) 1994    Arizona Board of Regents
 *
 * $Revision: 1.1 $
 * $Date: 1994/10/13 17:43:30 $
 */

#include "buffer.h"

#ifndef INGEN_UTILH
#define INGEN_UTILH

typedef struct code_level {
  Buffer *func_body;
  Buffer *func_vars;
  struct code_level *next;
} CodeLevel;

typedef struct namelist {
  char *name;
  struct namelist *next;
} NameList;

typedef enum { NORMAL_PARAM, BYTEVOID_PARAM, CASTVOID_PARAM } ParamFlag;

typedef enum { USC_OUTPUT, USIT_OUTPUT, USC_TYPES } OutputType;

extern Buffer *func_header, *func_body, *func_vars, *var_array_decl;
extern int code_stack_depth;


extern void genout (char *fmt, ...);
extern char *gen_offset (int x, Expr *expr);
extern void gen_func_header (Symbol* function);
extern void gen_func_name_header (char *type, char *ident);
extern void gen_func_close (void);
extern void push_code_level (void);
extern void pop_code_level (void);
extern void init_gen_utils (FILE *out);
extern void init_outfile (OutputType output_type);
extern void clear_deref_list(void);
extern void dont_deref (char *name);
extern int do_i_deref (char *name);
extern void genbuf (Buffer *buffer);
extern void write_eol (Buffer *buf);
extern void add_param(int n, Symbol *sym, ParamFlag flag, ... );
extern int compatible_return_type( Symbol* function, Symbol* sym );
extern char* symtype_to_string( Symbol* sym );
extern int pos_to_bit (ByteOrder order, int pos);
extern void bit_to_byte (Expr *offset);
extern int sym_bit_pos (Symbol *sym, int bit, Symbol *base_sym);
extern void write_fake_type( FILE* out, Symbol* sym );

#endif
